diff --git a/plugins/impstats/impstats.c b/plugins/impstats/impstats.c
index 078076887b..cf3b9a398f 100644
--- a/plugins/impstats/impstats.c
+++ b/plugins/impstats/impstats.c
@@ -135,6 +135,8 @@ static int st_ru_nvcsw;
 static int st_ru_nivcsw;
 static statsobj_t *statsobj_resources;
 
+static pthread_mutex_t hup_mutex = PTHREAD_MUTEX_INITIALIZER;
+
 BEGINmodExit
 CODESTARTmodExit
 	prop.Destruct(&pInputName);
@@ -234,8 +236,11 @@ doLogToFile(const char *ln, const size_t lenLn)
 	time_t t;
 	char timebuf[32];
 
+	pthread_mutex_lock(&hup_mutex);
+
 	if(lenLn == 0)
 		goto done;
+
 	if(runModConf->logfd == -1) {
 		runModConf->logfd = open(runModConf->logfile, O_WRONLY|O_CREAT|O_APPEND|O_CLOEXEC, S_IRUSR|S_IWUSR);
 		if(runModConf->logfd == -1) {
@@ -262,7 +267,9 @@ doLogToFile(const char *ln, const size_t lenLn)
 			dbgprintf("error writing stats file %s, nwritten %lld, expected %lld\n",
 				  runModConf->logfile, (long long) nwritten, (long long) nexpect);
 	}
-done:	return;
+done:
+	pthread_mutex_unlock(&hup_mutex);
+	return;
 }
 
 
@@ -451,6 +458,27 @@ checkRuleset(modConfData_t *modConf)
 	RETiRet;
 }
 
+
+/* to use HUP, we need to have an instanceData type, as this was
+ * originally designed for actions. However, we do not, and cannot,
+ * use the content. The core will always provide a NULL pointer.
+ */
+typedef struct _instanceData {
+	int dummy;
+} instanceData;
+BEGINdoHUP
+CODESTARTdoHUP
+	DBGPRINTF("impstats: received HUP\n")
+	pthread_mutex_lock(&hup_mutex);
+	if(runModConf->logfd != -1) {
+		DBGPRINTF("impstats: closing log file due to HUP\n");
+		//close(runModConf->logfd);
+		//runModConf->logfd = -1;
+	}
+	pthread_mutex_unlock(&hup_mutex);
+ENDdoHUP
+
+
 BEGINcheckCnf
 CODESTARTcheckCnf
 	if(pModConf->iStatsInterval == 0) {
@@ -554,6 +582,7 @@ CODEqueryEtryPt_STD_IMOD_QUERIES
 CODEqueryEtryPt_STD_CONF2_QUERIES
 CODEqueryEtryPt_STD_CONF2_setModCnf_QUERIES
 CODEqueryEtryPt_IsCompatibleWithFeature_IF_OMOD_QUERIES
+CODEqueryEtryPt_doHUP
 ENDqueryEtryPt
 
 static rsRetVal resetConfigVariables(uchar __attribute__((unused)) *pp, void __attribute__((unused)) *pVal)
diff --git a/runtime/modules.c b/runtime/modules.c
index b39b9b2fc6..6db060a898 100644
--- a/runtime/modules.c
+++ b/runtime/modules.c
@@ -663,6 +663,10 @@ doModInit(rsRetVal (*modInit)(int, int*, rsRetVal(**)(), rsRetVal(*)(), modInfo_
 			} else if(localRet != RS_RET_OK) {
 				ABORT_FINALIZE(localRet);
 			}
+			localRet = (*pNew->modQueryEtryPt)((uchar*)"doHUP", &pNew->doHUP);
+			if(localRet != RS_RET_OK && localRet != RS_RET_MODULE_ENTRY_POINT_NOT_FOUND)
+				ABORT_FINALIZE(localRet);
+
 			break;
 		case eMOD_OUT:
 			CHKiRet((*pNew->modQueryEtryPt)((uchar*)"freeInstance", &pNew->freeInstance));
@@ -946,6 +950,25 @@ static void modPrintList(void)
 }
 
 
+/* HUP all modules that support it - except for actions, which
+ * need (and have) specialised HUP handling.
+ */
+void
+modDoHUP(void)
+{
+	modInfo_t *pMod;
+
+	pMod = GetNxt(NULL);
+	while(pMod != NULL) {
+		if(pMod->eType != eMOD_OUT && pMod->doHUP != NULL) {
+			DBGPRINTF("HUPing module %s\n", (char*) modGetName(pMod));
+			pMod->doHUP(NULL);
+		}
+		pMod = GetNxt(pMod); /* done, go next */
+	}
+}
+
+
 /* unlink and destroy a module. The caller must provide a pointer to the module
  * itself as well as one to its immediate predecessor.
  * rgerhards, 2008-02-26
diff --git a/runtime/modules.h b/runtime/modules.h
index d66c2cade0..0a3868248c 100644
--- a/runtime/modules.h
+++ b/runtime/modules.h
@@ -203,5 +203,6 @@ rsRetVal modulesProcessCnf(struct cnfobj *o);
 uchar *modGetName(modInfo_t *pThis);
 rsRetVal addModToCnfList(cfgmodules_etry_t **pNew, cfgmodules_etry_t *pLast);
 rsRetVal readyModForCnf(modInfo_t *pThis, cfgmodules_etry_t **ppNew, cfgmodules_etry_t **ppLast);
+void modDoHUP(void);
 
 #endif /* #ifndef MODULES_H_INCLUDED */
diff --git a/tests/Makefile.am b/tests/Makefile.am
index baf59daab2..4e0f265df4 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -368,6 +368,7 @@ endif
 
 if ENABLE_IMPSTATS
 TESTS +=  \
+	impstats-hup.sh \
 	dynstats.sh \
 	dynstats_overflow.sh \
 	dynstats_reset.sh \
@@ -1372,6 +1373,7 @@ EXTRA_DIST= \
 	dynstats_overflow-vg.sh \
 	dynstats_reset.sh \
 	dynstats_reset-vg.sh \
+	impstats-hup.sh \
 	dynstats.sh \
 	dynstats-vg.sh \
 	dynstats_prevent_premature_eviction.sh \
diff --git a/tests/diag.sh b/tests/diag.sh
index fdd66de99c..ce7a9c89ec 100755
--- a/tests/diag.sh
+++ b/tests/diag.sh
@@ -483,6 +483,17 @@ case $1 in
 		done
 		echo "dyn-stats reset for bucket ${3} registered"
 		;;
+   'content-check')
+		# this does a content check which permits regex
+		grep "$2" $3
+		if [ "$?" -ne "0" ]; then
+		    echo "----------------------------------------------------------------------"
+		    echo content-check failed to find "'$2'" inside "'$3'"
+		    echo "file contents:"
+		    cat $3
+		    . $srcdir/diag.sh error-exit 1
+		fi
+		;;
    'custom-content-check') 
 		cat $3 | grep -qF "$2"
 		if [ "$?" -ne "0" ]; then
diff --git a/tests/impstats-hup.sh b/tests/impstats-hup.sh
new file mode 100755
index 0000000000..4a4229194d
--- /dev/null
+++ b/tests/impstats-hup.sh
@@ -0,0 +1,25 @@
+#!/bin/bash
+# test if HUP works for impstats
+# This file is part of the rsyslog project, released under ASL 2.0
+. $srcdir/diag.sh init
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+module(load="../plugins/impstats/.libs/impstats"
+	interval="1" ruleset="stats")
+
+ruleset(name="stats") {
+  action(type="omfile" file="./rsyslog.out.log")
+}
+'
+. $srcdir/diag.sh startup
+./msleep 2000
+mv rsyslog.out.log rsyslog2.out.log
+. $srcdir/diag.sh issue-HUP
+./msleep 2000
+. $srcdir/diag.sh shutdown-when-empty
+. $srcdir/diag.sh wait-shutdown
+echo checking pre-HUP file
+. $srcdir/diag.sh content-check 'global: origin=dynstats' rsyslog2.out.log
+echo checking post-HUP file
+. $srcdir/diag.sh content-check 'global: origin=dynstats' rsyslog.out.log
+. $srcdir/diag.sh exit
diff --git a/tools/rsyslogd.c b/tools/rsyslogd.c
index d2343aee87..5ac2bbf735 100644
--- a/tools/rsyslogd.c
+++ b/tools/rsyslogd.c
@@ -1605,6 +1605,7 @@ doHUP(void)
 
 	queryLocalHostname(); /* re-read our name */
 	ruleset.IterateAllActions(ourConf, doHUPActions, NULL);
+	modDoHUP();
 	lookupDoHUP();
 }
 
